; ###########################################################################
; original source from donkey
; adapted/modified by denise_amiga

.586						; create 32 bit code
.model flat, stdcall		; 32 bit memory model
option casemap :none		; case sensitive

include	windows.inc
include kernel32.inc

.code

; ###########################################################################

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 4

sa_Destroy proc pArray:DWORD

_index		= 0*4											; \
_count		= 1*4											; | extra
_size		= 2*4											; | data
_reserved	= 3*4											; /
_array		= 4*4											; <- begin array

	push	ebx
	push	edi

	mov		ebx, [esp+3*4]									; pArray
	mov		edi, [ebx+_size]								; size

	.while edi > 0
		mov		eax, [ebx+edi*4+_reserved]
		test	eax, eax									; ptr null?
		jz		@F

		invoke	GlobalFree, eax								; free strings
@@:
		sub		edi, 1
	.endw

	invoke	GlobalFree, ebx									; free array

	pop		edi
	pop		ebx
	ret		1*4

sa_Destroy endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; ###########################################################################

end
