; ###########################################################################
; original source from donkey
; adapted/modified by denise_amiga

.586						; create 32 bit code
.model flat, stdcall		; 32 bit memory model
option casemap :none		; case sensitive

include	windows.inc
include kernel32.inc

.code

; ###########################################################################

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 4

sa_Create proc MaxIndex:DWORD

_index		= 0*4											; \
_count		= 1*4											; | extra
_size		= 2*4											; | data
_reserved	= 3*4											; /
_array		= 4*4											; <- begin array

	mov		eax, [esp+1*4]									; MaxIndex
	push	eax
	add		eax, 4											; +4 (space for extra data)
	shl		eax, 2											; *4 (sizeof DWORD)
	invoke	GlobalAlloc, GMEM_FIXED or GMEM_ZEROINIT, eax
	pop		ecx
	test	eax, eax										; no memory?
	jz		@F												; return 0

	mov		[eax+_size], ecx								; set size=MaxIndex
@@:
	ret		1*4

sa_Create endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; ###########################################################################

end
