; ###########################################################################
; original source from donkey
; adapted/modified by denise_amiga

.586						; create 32 bit code
.model flat, stdcall		; 32 bit memory model
option casemap :none		; case sensitive

include	windows.inc
include kernel32.inc

.code

; ###########################################################################

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 4

sa_SetIndex proc pArray:DWORD,iNewIndex:DWORD

_index		= 0*4											; \
_count		= 1*4											; | extra
_size		= 2*4											; | data
_reserved	= 3*4											; /
_array		= 4*4											; <- begin array

	mov		edx, [esp+1*4]									; pArray
	mov		eax, [esp+2*4]									; iNewIndex
	mov		ecx, [edx+_size]								; size

	.if		(eax <= 0) || (eax > ecx)						; inside limits?
		mov		eax, -1										; return -1
		jmp		@F
	.endif

	mov		[edx+_index], eax
@@:
	ret		2*4

sa_SetIndex endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; ###########################################################################

end
